/* MountOperationAssistant.c generated by valac 0.16.1, the Vala compiler
 * generated from MountOperationAssistant.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkx.h>
#include <widgets.h>
#include <float.h>
#include <math.h>


#define TYPE_MOUNT_OPERATION_ASSISTANT (mount_operation_assistant_get_type ())
#define MOUNT_OPERATION_ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_OPERATION_ASSISTANT, MountOperationAssistant))
#define MOUNT_OPERATION_ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_OPERATION_ASSISTANT, MountOperationAssistantClass))
#define IS_MOUNT_OPERATION_ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_OPERATION_ASSISTANT))
#define IS_MOUNT_OPERATION_ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_OPERATION_ASSISTANT))
#define MOUNT_OPERATION_ASSISTANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_OPERATION_ASSISTANT, MountOperationAssistantClass))

typedef struct _MountOperationAssistant MountOperationAssistant;
typedef struct _MountOperationAssistantClass MountOperationAssistantClass;
typedef struct _MountOperationAssistantPrivate MountOperationAssistantPrivate;

#define TYPE_ASSISTANT (assistant_get_type ())
#define ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSISTANT, Assistant))
#define ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASSISTANT, AssistantClass))
#define IS_ASSISTANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSISTANT))
#define IS_ASSISTANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASSISTANT))
#define ASSISTANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASSISTANT, AssistantClass))

typedef struct _Assistant Assistant;
typedef struct _AssistantClass AssistantClass;

#define TYPE_ASSISTANT_OPERATION (assistant_operation_get_type ())
#define ASSISTANT_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSISTANT_OPERATION, AssistantOperation))
#define ASSISTANT_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASSISTANT_OPERATION, AssistantOperationClass))
#define IS_ASSISTANT_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSISTANT_OPERATION))
#define IS_ASSISTANT_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASSISTANT_OPERATION))
#define ASSISTANT_OPERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASSISTANT_OPERATION, AssistantOperationClass))

typedef struct _AssistantOperation AssistantOperation;
typedef struct _AssistantOperationClass AssistantOperationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define ASSISTANT_TYPE_TYPE (assistant_type_get_type ())

struct _MountOperationAssistant {
	GMountOperation parent_instance;
	MountOperationAssistantPrivate * priv;
};

struct _MountOperationAssistantClass {
	GMountOperationClass parent_class;
};

struct _MountOperationAssistantPrivate {
	gchar* _label_button;
	gchar* _label_help;
	gchar* _label_title;
	gchar* _label_username;
	gchar* _label_password;
	gchar* _label_show_password;
	gchar* _label_remember_password;
	Window _xid;
	gboolean _go_forward;
	AssistantOperation* _assist;
	GtkBin* password_page;
	GtkBox* layout;
	GtkGrid* table;
	GtkRadioButton* anonymous_w;
	GtkCheckButton* remember_w;
	GtkEntry* username_w;
	GtkEntry* domain_w;
	GtkEntry* password_w;
	gboolean looping;
};

typedef enum  {
	ASSISTANT_TYPE_NORMAL,
	ASSISTANT_TYPE_INTERRUPT,
	ASSISTANT_TYPE_SUMMARY,
	ASSISTANT_TYPE_PROGRESS,
	ASSISTANT_TYPE_FINISH
} AssistantType;


static gpointer mount_operation_assistant_parent_class = NULL;

GType mount_operation_assistant_get_type (void) G_GNUC_CONST;
GType assistant_get_type (void) G_GNUC_CONST;
GType assistant_operation_get_type (void) G_GNUC_CONST;
#define MOUNT_OPERATION_ASSISTANT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MOUNT_OPERATION_ASSISTANT, MountOperationAssistantPrivate))
enum  {
	MOUNT_OPERATION_ASSISTANT_DUMMY_PROPERTY,
	MOUNT_OPERATION_ASSISTANT_LABEL_BUTTON,
	MOUNT_OPERATION_ASSISTANT_LABEL_HELP,
	MOUNT_OPERATION_ASSISTANT_LABEL_TITLE,
	MOUNT_OPERATION_ASSISTANT_LABEL_USERNAME,
	MOUNT_OPERATION_ASSISTANT_LABEL_PASSWORD,
	MOUNT_OPERATION_ASSISTANT_LABEL_SHOW_PASSWORD,
	MOUNT_OPERATION_ASSISTANT_LABEL_REMEMBER_PASSWORD,
	MOUNT_OPERATION_ASSISTANT_XID,
	MOUNT_OPERATION_ASSISTANT_GO_FORWARD,
	MOUNT_OPERATION_ASSISTANT_ASSIST
};
MountOperationAssistant* mount_operation_assistant_new (AssistantOperation* assist);
MountOperationAssistant* mount_operation_assistant_construct (GType object_type, AssistantOperation* assist);
static void mount_operation_assistant_do_prepare (MountOperationAssistant* self, Assistant* assist, GtkWidget* page);
static void _mount_operation_assistant_do_prepare_assistant_prepare (Assistant* _sender, GtkWidget* page, gpointer self);
static void mount_operation_assistant_do_backward (MountOperationAssistant* self, Assistant* assist);
static void _mount_operation_assistant_do_backward_assistant_backward (Assistant* _sender, gpointer self);
static void mount_operation_assistant_do_forward (MountOperationAssistant* self, Assistant* assist);
static void _mount_operation_assistant_do_forward_assistant_forward (Assistant* _sender, gpointer self);
static void mount_operation_assistant_do_close (MountOperationAssistant* self, AssistantOperation* op, gboolean success);
static void _mount_operation_assistant_do_close_assistant_operation_closing (AssistantOperation* _sender, gboolean success, gpointer self);
static void mount_operation_assistant_add_password_page (MountOperationAssistant* self);
static void mount_operation_assistant_set_xid (MountOperationAssistant* self, Window value);
static void mount_operation_assistant_go_forward_changed (MountOperationAssistant* mop);
gboolean mount_operation_assistant_get_go_forward (MountOperationAssistant* self);
AssistantOperation* mount_operation_assistant_get_assist (MountOperationAssistant* self);
void assistant_go_forward (Assistant* self);
static void mount_operation_assistant_real_aborted (GMountOperation* base);
void assistant_operation_show_error (AssistantOperation* self, const gchar* _error_, const gchar* detail);
static void mount_operation_assistant_real_ask_password (GMountOperation* base, const gchar* message, const gchar* default_user, const gchar* default_domain, GAskPasswordFlags flags);
static void mount_operation_assistant_flesh_out_password_page (MountOperationAssistant* self, const gchar* message, const gchar* default_user, const gchar* default_domain, GAskPasswordFlags flags);
void assistant_interrupt (Assistant* self, GtkWidget* page, gboolean can_continue);
static void mount_operation_assistant_check_valid_inputs (MountOperationAssistant* self);
void assistant_set_header_icon (Assistant* self, const gchar* name);
void assistant_operation_force_visible (AssistantOperation* self, gboolean user_click);
static void mount_operation_assistant_real_ask_question (GMountOperation* base, const gchar* message, gchar** choices);
static void __lambda25_ (MountOperationAssistant* self, GMountOperation* t, GMountOperationResult r);
static void mount_operation_assistant_send_reply (MountOperationAssistant* self, GMountOperationResult _result_);
static void ___lambda25__g_mount_operation_reply (GMountOperation* _sender, GMountOperationResult _result_, gpointer self);
GType assistant_type_get_type (void) G_GNUC_CONST;
void assistant_append_page (Assistant* self, GtkWidget* page, AssistantType type);
void assistant_set_page_title (Assistant* self, GtkWidget* page, const gchar* title);
const gchar* mount_operation_assistant_get_label_title (MountOperationAssistant* self);
const gchar* mount_operation_assistant_get_label_help (MountOperationAssistant* self);
const gchar* mount_operation_assistant_get_label_button (MountOperationAssistant* self);
static void ___lambda19_ (MountOperationAssistant* self);
static void ____lambda19__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void ___lambda20_ (MountOperationAssistant* self, GtkToggleButton* b);
static void ____lambda20__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void ___lambda21_ (MountOperationAssistant* self, GtkToggleButton* b);
static void ____lambda21__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void ___lambda22_ (MountOperationAssistant* self, GtkEditable* e);
static void ____lambda22__gtk_editable_changed (GtkEditable* _sender, gpointer self);
const gchar* mount_operation_assistant_get_label_username (MountOperationAssistant* self);
static void ___lambda23_ (MountOperationAssistant* self, GtkEditable* e);
static void ____lambda23__gtk_editable_changed (GtkEditable* _sender, gpointer self);
const gchar* mount_operation_assistant_get_label_password (MountOperationAssistant* self);
const gchar* mount_operation_assistant_get_label_show_password (MountOperationAssistant* self);
static void ___lambda24_ (MountOperationAssistant* self, GtkToggleButton* button);
static void ____lambda24__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
const gchar* mount_operation_assistant_get_label_remember_password (MountOperationAssistant* self);
static gboolean mount_operation_assistant_is_valid_entry (MountOperationAssistant* self, GtkEntry* e);
static gboolean mount_operation_assistant_is_anonymous (MountOperationAssistant* self);
void assistant_allow_forward (Assistant* self, gboolean allow);
void mount_operation_assistant_set_label_button (MountOperationAssistant* self, const gchar* value);
void mount_operation_assistant_set_label_help (MountOperationAssistant* self, const gchar* value);
void mount_operation_assistant_set_label_title (MountOperationAssistant* self, const gchar* value);
void mount_operation_assistant_set_label_username (MountOperationAssistant* self, const gchar* value);
void mount_operation_assistant_set_label_password (MountOperationAssistant* self, const gchar* value);
void mount_operation_assistant_set_label_show_password (MountOperationAssistant* self, const gchar* value);
void mount_operation_assistant_set_label_remember_password (MountOperationAssistant* self, const gchar* value);
Window mount_operation_assistant_get_xid (MountOperationAssistant* self);
void mount_operation_assistant_set_go_forward (MountOperationAssistant* self, gboolean value);
static void mount_operation_assistant_set_assist (MountOperationAssistant* self, AssistantOperation* value);
static GObject * mount_operation_assistant_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void mount_operation_assistant_finalize (GObject* obj);
static void _vala_mount_operation_assistant_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_mount_operation_assistant_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _mount_operation_assistant_do_prepare_assistant_prepare (Assistant* _sender, GtkWidget* page, gpointer self) {
	mount_operation_assistant_do_prepare (self, _sender, page);
}


static void _mount_operation_assistant_do_backward_assistant_backward (Assistant* _sender, gpointer self) {
	mount_operation_assistant_do_backward (self, _sender);
}


static void _mount_operation_assistant_do_forward_assistant_forward (Assistant* _sender, gpointer self) {
	mount_operation_assistant_do_forward (self, _sender);
}


static void _mount_operation_assistant_do_close_assistant_operation_closing (AssistantOperation* _sender, gboolean success, gpointer self) {
	mount_operation_assistant_do_close (self, _sender, success);
}


MountOperationAssistant* mount_operation_assistant_construct (GType object_type, AssistantOperation* assist) {
	MountOperationAssistant * self = NULL;
	AssistantOperation* _tmp0_;
	AssistantOperation* _tmp1_;
	AssistantOperation* _tmp2_;
	AssistantOperation* _tmp3_;
	AssistantOperation* _tmp4_;
	AssistantOperation* _tmp5_;
	AssistantOperation* _tmp6_;
	GdkWindow* _tmp7_ = NULL;
	Window _tmp8_ = 0;
	g_return_val_if_fail (assist != NULL, NULL);
	_tmp0_ = assist;
	self = (MountOperationAssistant*) g_object_new (object_type, "assist", _tmp0_, NULL);
	_tmp1_ = assist;
	g_signal_connect_object ((Assistant*) _tmp1_, "prepare", (GCallback) _mount_operation_assistant_do_prepare_assistant_prepare, self, 0);
	_tmp2_ = assist;
	g_signal_connect_object ((Assistant*) _tmp2_, "backward", (GCallback) _mount_operation_assistant_do_backward_assistant_backward, self, 0);
	_tmp3_ = assist;
	g_signal_connect_object ((Assistant*) _tmp3_, "forward", (GCallback) _mount_operation_assistant_do_forward_assistant_forward, self, 0);
	_tmp4_ = assist;
	g_signal_connect_object (_tmp4_, "closing", (GCallback) _mount_operation_assistant_do_close_assistant_operation_closing, self, 0);
	mount_operation_assistant_add_password_page (self);
	_tmp5_ = assist;
	gtk_widget_realize ((GtkWidget*) _tmp5_);
	_tmp6_ = assist;
	_tmp7_ = gtk_widget_get_window ((GtkWidget*) _tmp6_);
	_tmp8_ = gdk_x11_window_get_xid (_tmp7_);
	mount_operation_assistant_set_xid (self, _tmp8_);
	return self;
}


MountOperationAssistant* mount_operation_assistant_new (AssistantOperation* assist) {
	return mount_operation_assistant_construct (TYPE_MOUNT_OPERATION_ASSISTANT, assist);
}


static void mount_operation_assistant_go_forward_changed (MountOperationAssistant* mop) {
	MountOperationAssistant* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (mop != NULL);
	_tmp0_ = mop;
	_tmp1_ = _tmp0_->priv->_go_forward;
	if (_tmp1_) {
		MountOperationAssistant* _tmp2_;
		AssistantOperation* _tmp3_;
		_tmp2_ = mop;
		_tmp3_ = _tmp2_->priv->_assist;
		assistant_go_forward ((Assistant*) _tmp3_);
	}
}


static void mount_operation_assistant_real_aborted (GMountOperation* base) {
	MountOperationAssistant * self;
	AssistantOperation* _tmp0_;
	const gchar* _tmp1_ = NULL;
	self = (MountOperationAssistant*) base;
	_tmp0_ = self->priv->_assist;
	_tmp1_ = _ ("Location not available");
	assistant_operation_show_error (_tmp0_, _tmp1_, NULL);
}


static void mount_operation_assistant_real_ask_password (GMountOperation* base, const gchar* message, const gchar* default_user, const gchar* default_domain, GAskPasswordFlags flags) {
	MountOperationAssistant * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GAskPasswordFlags _tmp3_;
	AssistantOperation* _tmp4_;
	GtkBin* _tmp5_;
	AssistantOperation* _tmp6_;
	AssistantOperation* _tmp7_;
	self = (MountOperationAssistant*) base;
	g_return_if_fail (message != NULL);
	g_return_if_fail (default_user != NULL);
	g_return_if_fail (default_domain != NULL);
	_tmp0_ = message;
	_tmp1_ = default_user;
	_tmp2_ = default_domain;
	_tmp3_ = flags;
	mount_operation_assistant_flesh_out_password_page (self, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
	_tmp4_ = self->priv->_assist;
	_tmp5_ = self->priv->password_page;
	assistant_interrupt ((Assistant*) _tmp4_, (GtkWidget*) _tmp5_, TRUE);
	self->priv->looping = TRUE;
	mount_operation_assistant_check_valid_inputs (self);
	_tmp6_ = self->priv->_assist;
	assistant_set_header_icon ((Assistant*) _tmp6_, GTK_STOCK_DIALOG_AUTHENTICATION);
	_tmp7_ = self->priv->_assist;
	assistant_operation_force_visible (_tmp7_, FALSE);
	gtk_main ();
}


static void __lambda25_ (MountOperationAssistant* self, GMountOperation* t, GMountOperationResult r) {
	GMountOperation* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GMountOperationResult _tmp3_;
	g_return_if_fail (t != NULL);
	_tmp0_ = t;
	_tmp1_ = g_mount_operation_get_choice (_tmp0_);
	_tmp2_ = _tmp1_;
	g_mount_operation_set_choice ((GMountOperation*) self, _tmp2_);
	_tmp3_ = r;
	mount_operation_assistant_send_reply (self, _tmp3_);
}


static void ___lambda25__g_mount_operation_reply (GMountOperation* _sender, GMountOperationResult _result_, gpointer self) {
	__lambda25_ (self, _sender, _result_);
}


static void mount_operation_assistant_real_ask_question (GMountOperation* base, const gchar* message, gchar** choices) {
	MountOperationAssistant * self;
	AssistantOperation* _tmp0_;
	GtkMountOperation* _tmp1_;
	GtkMountOperation* t;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	self = (MountOperationAssistant*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = self->priv->_assist;
	_tmp1_ = (GtkMountOperation*) gtk_mount_operation_new ((GtkWindow*) _tmp0_);
	t = _tmp1_;
	g_signal_connect_object ((GMountOperation*) t, "reply", (GCallback) ___lambda25__g_mount_operation_reply, self, 0);
	self->priv->looping = TRUE;
	_tmp2_ = message;
	_tmp3_ = choices;
	_tmp3__length1 = -1;
	g_signal_emit_by_name ((GMountOperation*) t, "ask-question", _tmp2_, _tmp3_);
	gtk_main ();
	_g_object_unref0 (t);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void mount_operation_assistant_add_password_page (MountOperationAssistant* self) {
	GtkEventBox* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkEventBox* page;
	AssistantOperation* _tmp2_;
	GtkBin* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkEventBox*) gtk_event_box_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	page = _tmp1_;
	_tmp2_ = self->priv->_assist;
	assistant_append_page ((Assistant*) _tmp2_, (GtkWidget*) page, ASSISTANT_TYPE_INTERRUPT);
	_tmp3_ = _g_object_ref0 ((GtkBin*) page);
	_g_object_unref0 (self->priv->password_page);
	self->priv->password_page = _tmp3_;
	_g_object_unref0 (page);
}


static void ___lambda19_ (MountOperationAssistant* self) {
	g_signal_emit_by_name (self, "button-clicked");
}


static void ____lambda19__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	___lambda19_ (self);
}


static void ___lambda20_ (MountOperationAssistant* self, GtkToggleButton* b) {
	g_return_if_fail (b != NULL);
	mount_operation_assistant_check_valid_inputs (self);
}


static void ____lambda20__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	___lambda20_ (self, _sender);
}


static void ___lambda21_ (MountOperationAssistant* self, GtkToggleButton* b) {
	GtkGrid* _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (b != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = b;
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, !_tmp3_);
}


static void ____lambda21__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	___lambda21_ (self, _sender);
}


static void ___lambda22_ (MountOperationAssistant* self, GtkEditable* e) {
	g_return_if_fail (e != NULL);
	mount_operation_assistant_check_valid_inputs (self);
}


static void ____lambda22__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	___lambda22_ (self, _sender);
}


static void ___lambda23_ (MountOperationAssistant* self, GtkEditable* e) {
	g_return_if_fail (e != NULL);
	mount_operation_assistant_check_valid_inputs (self);
}


static void ____lambda23__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	___lambda23_ (self, _sender);
}


static void ___lambda24_ (MountOperationAssistant* self, GtkToggleButton* button) {
	GtkEntry* _tmp0_;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (button != NULL);
	_tmp0_ = self->priv->password_w;
	_tmp1_ = button;
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	gtk_entry_set_visibility (_tmp0_, _tmp2_);
}


static void ____lambda24__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	___lambda24_ (self, _sender);
}


static void mount_operation_assistant_flesh_out_password_page (MountOperationAssistant* self, const gchar* message, const gchar* default_user, const gchar* default_domain, GAskPasswordFlags flags) {
	GtkBox* _tmp0_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkGrid* _tmp5_;
	GtkGrid* _tmp6_;
	GtkGrid* _tmp7_;
	GtkBin* _tmp8_;
	GtkBox* _tmp9_;
	gint rows;
	gint ucol;
	GtkLabel* label = NULL;
	AssistantOperation* _tmp10_;
	GtkBin* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkBox* _tmp19_;
	GtkLabel* _tmp20_;
	const gchar* _tmp21_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* _tmp32_;
	GtkLabel* _tmp33_;
	const gchar* _tmp34_;
	GAskPasswordFlags _tmp45_;
	GAskPasswordFlags _tmp71_;
	GAskPasswordFlags _tmp93_;
	GAskPasswordFlags _tmp115_;
	GAskPasswordFlags _tmp145_;
	GtkBin* _tmp155_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	g_return_if_fail (default_user != NULL);
	g_return_if_fail (default_domain != NULL);
	_tmp0_ = self->priv->layout;
	if (_tmp0_ != NULL) {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->layout;
		deja_dup_destroy_widget ((GtkWidget*) _tmp1_);
	}
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	_tmp3_ = g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->layout);
	self->priv->layout = _tmp3_;
	_tmp4_ = self->priv->layout;
	g_object_set ((GObject*) _tmp4_, "border-width", 12, NULL);
	_tmp5_ = (GtkGrid*) gtk_grid_new ();
	_tmp6_ = g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->table);
	self->priv->table = _tmp6_;
	_tmp7_ = self->priv->table;
	g_object_set ((GObject*) _tmp7_, "row-spacing", 6, "column-spacing", 6, NULL);
	_tmp8_ = self->priv->password_page;
	_tmp9_ = self->priv->layout;
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
	rows = 0;
	ucol = 0;
	_tmp10_ = self->priv->_assist;
	_tmp11_ = self->priv->password_page;
	_tmp12_ = self->priv->_label_title;
	assistant_set_page_title ((Assistant*) _tmp10_, (GtkWidget*) _tmp11_, _tmp12_);
	_tmp13_ = message;
	_tmp14_ = (GtkLabel*) gtk_label_new (_tmp13_);
	_tmp15_ = g_object_ref_sink (_tmp14_);
	_g_object_unref0 (label);
	label = _tmp15_;
	_tmp16_ = label;
	g_object_set ((GtkMisc*) _tmp16_, "xalign", 0.0f, NULL);
	_tmp17_ = label;
	g_object_set (_tmp17_, "wrap", TRUE, NULL);
	_tmp18_ = label;
	gtk_label_set_max_width_chars (_tmp18_, 25);
	_tmp19_ = self->priv->layout;
	_tmp20_ = label;
	gtk_box_pack_start (_tmp19_, (GtkWidget*) _tmp20_, FALSE, FALSE, (guint) 0);
	_tmp21_ = self->priv->_label_help;
	if (_tmp21_ != NULL) {
		const gchar* _tmp22_;
		GtkLabel* _tmp23_;
		GtkLabel* _tmp24_;
		GtkLabel* _tmp25_;
		GtkLabel* _tmp26_;
		GtkLabel* _tmp27_;
		GtkBox* _tmp28_;
		GtkLabel* _tmp29_;
		_tmp22_ = self->priv->_label_help;
		_tmp23_ = (GtkLabel*) gtk_label_new (_tmp22_);
		_tmp24_ = g_object_ref_sink (_tmp23_);
		_g_object_unref0 (label);
		label = _tmp24_;
		_tmp25_ = label;
		gtk_label_set_use_markup (_tmp25_, TRUE);
		_tmp26_ = label;
		gtk_label_set_track_visited_links (_tmp26_, FALSE);
		_tmp27_ = label;
		g_object_set ((GObject*) _tmp27_, "xalign", 0.f, NULL);
		_tmp28_ = self->priv->layout;
		_tmp29_ = label;
		gtk_box_pack_start (_tmp28_, (GtkWidget*) _tmp29_, FALSE, FALSE, (guint) 0);
	}
	_tmp30_ = (GtkLabel*) gtk_label_new ("");
	_tmp31_ = g_object_ref_sink (_tmp30_);
	_g_object_unref0 (label);
	label = _tmp31_;
	_tmp32_ = self->priv->layout;
	_tmp33_ = label;
	gtk_box_pack_start (_tmp32_, (GtkWidget*) _tmp33_, FALSE, FALSE, (guint) 0);
	_tmp34_ = self->priv->_label_button;
	if (_tmp34_ != NULL) {
		GtkAlignment* _tmp35_;
		GtkAlignment* _tmp36_;
		GtkAlignment* alignment;
		const gchar* _tmp37_;
		GtkButton* _tmp38_;
		GtkButton* _tmp39_;
		GtkButton* button;
		GtkButton* _tmp40_;
		GtkAlignment* _tmp41_;
		GtkButton* _tmp42_;
		GtkBox* _tmp43_;
		GtkAlignment* _tmp44_;
		_tmp35_ = (GtkAlignment*) gtk_alignment_new (0.5f, 0.5f, (gfloat) 0, (gfloat) 0);
		_tmp36_ = g_object_ref_sink (_tmp35_);
		alignment = _tmp36_;
		_tmp37_ = self->priv->_label_button;
		_tmp38_ = (GtkButton*) gtk_button_new_with_mnemonic (_tmp37_);
		_tmp39_ = g_object_ref_sink (_tmp38_);
		button = _tmp39_;
		_tmp40_ = button;
		g_signal_connect_object (_tmp40_, "clicked", (GCallback) ____lambda19__gtk_button_clicked, self, 0);
		_tmp41_ = alignment;
		_tmp42_ = button;
		gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
		_tmp43_ = self->priv->layout;
		_tmp44_ = alignment;
		gtk_box_pack_start (_tmp43_, (GtkWidget*) _tmp44_, FALSE, FALSE, (guint) 0);
		_g_object_unref0 (button);
		_g_object_unref0 (alignment);
	}
	_tmp45_ = flags;
	if ((_tmp45_ & G_ASK_PASSWORD_ANONYMOUS_SUPPORTED) != 0) {
		const gchar* _tmp46_ = NULL;
		GtkRadioButton* _tmp47_;
		GtkRadioButton* _tmp48_;
		GtkRadioButton* _tmp49_;
		GtkBox* _tmp50_;
		GtkRadioButton* _tmp51_;
		GtkRadioButton* _tmp52_;
		const gchar* _tmp53_ = NULL;
		GtkRadioButton* _tmp54_;
		GtkRadioButton* _tmp55_;
		GtkRadioButton* w;
		GtkRadioButton* _tmp56_;
		GtkGrid* _tmp57_;
		GtkBox* _tmp58_;
		GtkRadioButton* _tmp59_;
		GtkBox* _tmp60_;
		GtkBox* _tmp61_;
		GtkBox* hbox;
		GtkBox* _tmp62_;
		GtkLabel* _tmp63_;
		GtkLabel* _tmp64_;
		GtkBox* _tmp65_;
		GtkGrid* _tmp66_;
		GtkBox* _tmp67_;
		GtkBox* _tmp68_;
		_tmp46_ = _ ("Connect _anonymously");
		_tmp47_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic (NULL, _tmp46_);
		_tmp48_ = g_object_ref_sink (_tmp47_);
		_g_object_unref0 (self->priv->anonymous_w);
		self->priv->anonymous_w = _tmp48_;
		_tmp49_ = self->priv->anonymous_w;
		g_signal_connect_object ((GtkToggleButton*) _tmp49_, "toggled", (GCallback) ____lambda20__gtk_toggle_button_toggled, self, 0);
		_tmp50_ = self->priv->layout;
		_tmp51_ = self->priv->anonymous_w;
		gtk_box_pack_start (_tmp50_, (GtkWidget*) _tmp51_, FALSE, FALSE, (guint) 0);
		_tmp52_ = self->priv->anonymous_w;
		_tmp53_ = _ ("Connect as u_ser");
		_tmp54_ = (GtkRadioButton*) gtk_radio_button_new_with_mnemonic_from_widget (_tmp52_, _tmp53_);
		_tmp55_ = g_object_ref_sink (_tmp54_);
		w = _tmp55_;
		_tmp56_ = self->priv->anonymous_w;
		g_signal_connect_object ((GtkToggleButton*) _tmp56_, "toggled", (GCallback) ____lambda21__gtk_toggle_button_toggled, self, 0);
		_tmp57_ = self->priv->table;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp57_, FALSE);
		_tmp58_ = self->priv->layout;
		_tmp59_ = w;
		gtk_box_pack_start (_tmp58_, (GtkWidget*) _tmp59_, FALSE, FALSE, (guint) 0);
		_tmp60_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
		_tmp61_ = g_object_ref_sink (_tmp60_);
		hbox = _tmp61_;
		_tmp62_ = hbox;
		_tmp63_ = (GtkLabel*) gtk_label_new ("    ");
		_tmp64_ = g_object_ref_sink (_tmp63_);
		gtk_box_pack_start (_tmp62_, (GtkWidget*) _tmp64_, FALSE, FALSE, (guint) 0);
		_g_object_unref0 (_tmp64_);
		_tmp65_ = hbox;
		_tmp66_ = self->priv->table;
		gtk_box_pack_start (_tmp65_, (GtkWidget*) _tmp66_, TRUE, TRUE, (guint) 0);
		_tmp67_ = self->priv->layout;
		_tmp68_ = hbox;
		gtk_box_pack_start (_tmp67_, (GtkWidget*) _tmp68_, FALSE, FALSE, (guint) 0);
		ucol = 1;
		_g_object_unref0 (hbox);
		_g_object_unref0 (w);
	} else {
		GtkBox* _tmp69_;
		GtkGrid* _tmp70_;
		_g_object_unref0 (self->priv->anonymous_w);
		self->priv->anonymous_w = NULL;
		_tmp69_ = self->priv->layout;
		_tmp70_ = self->priv->table;
		gtk_box_pack_start (_tmp69_, (GtkWidget*) _tmp70_, FALSE, FALSE, (guint) 0);
	}
	_tmp71_ = flags;
	if ((_tmp71_ & G_ASK_PASSWORD_NEED_USERNAME) != 0) {
		GtkEntry* _tmp72_;
		GtkEntry* _tmp73_;
		GtkEntry* _tmp74_;
		const gchar* _tmp75_;
		GtkEntry* _tmp76_;
		GtkEntry* _tmp77_;
		const gchar* _tmp78_;
		GtkLabel* _tmp79_;
		GtkLabel* _tmp80_;
		GtkLabel* _tmp81_;
		GtkEntry* _tmp82_;
		GtkGrid* _tmp83_;
		GtkLabel* _tmp84_;
		gint _tmp85_;
		gint _tmp86_;
		GtkGrid* _tmp87_;
		GtkEntry* _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		gint _tmp91_;
		gint _tmp92_;
		_tmp72_ = (GtkEntry*) gtk_entry_new ();
		_tmp73_ = g_object_ref_sink (_tmp72_);
		_g_object_unref0 (self->priv->username_w);
		self->priv->username_w = _tmp73_;
		_tmp74_ = self->priv->username_w;
		_tmp75_ = default_user;
		g_object_set ((GObject*) _tmp74_, "activates-default", TRUE, "text", _tmp75_, NULL);
		_tmp76_ = self->priv->username_w;
		gtk_widget_set_hexpand ((GtkWidget*) _tmp76_, TRUE);
		_tmp77_ = self->priv->username_w;
		g_signal_connect_object ((GtkEditable*) _tmp77_, "changed", (GCallback) ____lambda22__gtk_editable_changed, self, 0);
		_tmp78_ = self->priv->_label_username;
		_tmp79_ = (GtkLabel*) gtk_label_new (_tmp78_);
		_tmp80_ = g_object_ref_sink (_tmp79_);
		_g_object_unref0 (label);
		label = _tmp80_;
		_tmp81_ = label;
		_tmp82_ = self->priv->username_w;
		g_object_set ((GObject*) _tmp81_, "mnemonic-widget", _tmp82_, "use-underline", TRUE, "xalign", 1.0f, NULL);
		_tmp83_ = self->priv->table;
		_tmp84_ = label;
		_tmp85_ = ucol;
		_tmp86_ = rows;
		gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, _tmp85_, _tmp86_, 1, 1);
		_tmp87_ = self->priv->table;
		_tmp88_ = self->priv->username_w;
		_tmp89_ = ucol;
		_tmp90_ = rows;
		_tmp91_ = ucol;
		gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, _tmp89_ + 1, _tmp90_, 2 - _tmp91_, 1);
		_tmp92_ = rows;
		rows = _tmp92_ + 1;
	} else {
		_g_object_unref0 (self->priv->username_w);
		self->priv->username_w = NULL;
	}
	_tmp93_ = flags;
	if ((_tmp93_ & G_ASK_PASSWORD_NEED_DOMAIN) != 0) {
		GtkEntry* _tmp94_;
		GtkEntry* _tmp95_;
		GtkEntry* _tmp96_;
		const gchar* _tmp97_;
		GtkEntry* _tmp98_;
		GtkEntry* _tmp99_;
		const gchar* _tmp100_ = NULL;
		GtkLabel* _tmp101_;
		GtkLabel* _tmp102_;
		GtkLabel* _tmp103_;
		GtkEntry* _tmp104_;
		GtkGrid* _tmp105_;
		GtkLabel* _tmp106_;
		gint _tmp107_;
		gint _tmp108_;
		GtkGrid* _tmp109_;
		GtkEntry* _tmp110_;
		gint _tmp111_;
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		_tmp94_ = (GtkEntry*) gtk_entry_new ();
		_tmp95_ = g_object_ref_sink (_tmp94_);
		_g_object_unref0 (self->priv->domain_w);
		self->priv->domain_w = _tmp95_;
		_tmp96_ = self->priv->domain_w;
		_tmp97_ = default_domain;
		g_object_set ((GObject*) _tmp96_, "activates-default", TRUE, "text", _tmp97_, NULL);
		_tmp98_ = self->priv->domain_w;
		gtk_widget_set_hexpand ((GtkWidget*) _tmp98_, TRUE);
		_tmp99_ = self->priv->domain_w;
		g_signal_connect_object ((GtkEditable*) _tmp99_, "changed", (GCallback) ____lambda23__gtk_editable_changed, self, 0);
		_tmp100_ = _ ("_Domain");
		_tmp101_ = (GtkLabel*) gtk_label_new (_tmp100_);
		_tmp102_ = g_object_ref_sink (_tmp101_);
		_g_object_unref0 (label);
		label = _tmp102_;
		_tmp103_ = label;
		_tmp104_ = self->priv->domain_w;
		g_object_set ((GObject*) _tmp103_, "mnemonic-widget", _tmp104_, "use-underline", TRUE, "xalign", 1.0f, NULL);
		_tmp105_ = self->priv->table;
		_tmp106_ = label;
		_tmp107_ = ucol;
		_tmp108_ = rows;
		gtk_grid_attach (_tmp105_, (GtkWidget*) _tmp106_, _tmp107_, _tmp108_, 1, 1);
		_tmp109_ = self->priv->table;
		_tmp110_ = self->priv->domain_w;
		_tmp111_ = ucol;
		_tmp112_ = rows;
		_tmp113_ = ucol;
		gtk_grid_attach (_tmp109_, (GtkWidget*) _tmp110_, _tmp111_ + 1, _tmp112_, 2 - _tmp113_, 1);
		_tmp114_ = rows;
		rows = _tmp114_ + 1;
	} else {
		_g_object_unref0 (self->priv->domain_w);
		self->priv->domain_w = NULL;
	}
	_tmp115_ = flags;
	if ((_tmp115_ & G_ASK_PASSWORD_NEED_PASSWORD) != 0) {
		GtkEntry* _tmp116_;
		GtkEntry* _tmp117_;
		GtkEntry* _tmp118_;
		GtkEntry* _tmp119_;
		const gchar* _tmp120_;
		GtkLabel* _tmp121_;
		GtkLabel* _tmp122_;
		GtkLabel* _tmp123_;
		GtkEntry* _tmp124_;
		GtkGrid* _tmp125_;
		GtkLabel* _tmp126_;
		gint _tmp127_;
		gint _tmp128_;
		GtkGrid* _tmp129_;
		GtkEntry* _tmp130_;
		gint _tmp131_;
		gint _tmp132_;
		gint _tmp133_;
		gint _tmp134_;
		const gchar* _tmp135_;
		GtkCheckButton* _tmp136_;
		GtkCheckButton* _tmp137_;
		GtkCheckButton* w;
		GtkCheckButton* _tmp138_;
		GtkGrid* _tmp139_;
		GtkCheckButton* _tmp140_;
		gint _tmp141_;
		gint _tmp142_;
		gint _tmp143_;
		gint _tmp144_;
		_tmp116_ = (GtkEntry*) gtk_entry_new ();
		_tmp117_ = g_object_ref_sink (_tmp116_);
		_g_object_unref0 (self->priv->password_w);
		self->priv->password_w = _tmp117_;
		_tmp118_ = self->priv->password_w;
		g_object_set ((GObject*) _tmp118_, "visibility", FALSE, "activates-default", TRUE, NULL);
		_tmp119_ = self->priv->password_w;
		gtk_widget_set_hexpand ((GtkWidget*) _tmp119_, TRUE);
		_tmp120_ = self->priv->_label_password;
		_tmp121_ = (GtkLabel*) gtk_label_new (_tmp120_);
		_tmp122_ = g_object_ref_sink (_tmp121_);
		_g_object_unref0 (label);
		label = _tmp122_;
		_tmp123_ = label;
		_tmp124_ = self->priv->password_w;
		g_object_set ((GObject*) _tmp123_, "mnemonic-widget", _tmp124_, "use-underline", TRUE, "xalign", 1.0f, NULL);
		_tmp125_ = self->priv->table;
		_tmp126_ = label;
		_tmp127_ = ucol;
		_tmp128_ = rows;
		gtk_grid_attach (_tmp125_, (GtkWidget*) _tmp126_, _tmp127_, _tmp128_, 1, 1);
		_tmp129_ = self->priv->table;
		_tmp130_ = self->priv->password_w;
		_tmp131_ = ucol;
		_tmp132_ = rows;
		_tmp133_ = ucol;
		gtk_grid_attach (_tmp129_, (GtkWidget*) _tmp130_, _tmp131_ + 1, _tmp132_, 2 - _tmp133_, 1);
		_tmp134_ = rows;
		rows = _tmp134_ + 1;
		_tmp135_ = self->priv->_label_show_password;
		_tmp136_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp135_);
		_tmp137_ = g_object_ref_sink (_tmp136_);
		w = _tmp137_;
		_tmp138_ = w;
		g_signal_connect_object ((GtkToggleButton*) GTK_CHECK_BUTTON (_tmp138_), "toggled", (GCallback) ____lambda24__gtk_toggle_button_toggled, self, 0);
		_tmp139_ = self->priv->table;
		_tmp140_ = w;
		_tmp141_ = ucol;
		_tmp142_ = rows;
		_tmp143_ = ucol;
		gtk_grid_attach (_tmp139_, (GtkWidget*) _tmp140_, _tmp141_ + 1, _tmp142_, 2 - _tmp143_, 1);
		_tmp144_ = rows;
		rows = _tmp144_ + 1;
		_g_object_unref0 (w);
	} else {
		_g_object_unref0 (self->priv->password_w);
		self->priv->password_w = NULL;
	}
	_tmp145_ = flags;
	if ((_tmp145_ & G_ASK_PASSWORD_SAVING_SUPPORTED) != 0) {
		const gchar* _tmp146_;
		GtkCheckButton* _tmp147_;
		GtkCheckButton* _tmp148_;
		GtkGrid* _tmp149_;
		GtkCheckButton* _tmp150_;
		gint _tmp151_;
		gint _tmp152_;
		gint _tmp153_;
		gint _tmp154_;
		_tmp146_ = self->priv->_label_remember_password;
		_tmp147_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp146_);
		_tmp148_ = g_object_ref_sink (_tmp147_);
		_g_object_unref0 (self->priv->remember_w);
		self->priv->remember_w = _tmp148_;
		_tmp149_ = self->priv->table;
		_tmp150_ = self->priv->remember_w;
		_tmp151_ = ucol;
		_tmp152_ = rows;
		_tmp153_ = ucol;
		gtk_grid_attach (_tmp149_, (GtkWidget*) _tmp150_, _tmp151_ + 1, _tmp152_, 2 - _tmp153_, 1);
		_tmp154_ = rows;
		rows = _tmp154_ + 1;
	} else {
		_g_object_unref0 (self->priv->remember_w);
		self->priv->remember_w = NULL;
	}
	_tmp155_ = self->priv->password_page;
	gtk_widget_show_all ((GtkWidget*) _tmp155_);
	_g_object_unref0 (label);
}


static gboolean mount_operation_assistant_is_valid_entry (MountOperationAssistant* self, GtkEntry* e) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	gboolean _tmp10_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = e;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		GtkEntry* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gboolean _tmp9_;
		_tmp3_ = e;
		_tmp4_ = gtk_entry_get_text (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ != NULL) {
			GtkEntry* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			_tmp6_ = e;
			_tmp7_ = gtk_entry_get_text (_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp2_ = g_strcmp0 (_tmp8_, "") != 0;
		} else {
			_tmp2_ = FALSE;
		}
		_tmp9_ = _tmp2_;
		_tmp0_ = _tmp9_;
	}
	_tmp10_ = _tmp0_;
	result = _tmp10_;
	return result;
}


static gboolean mount_operation_assistant_is_anonymous (MountOperationAssistant* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkRadioButton* _tmp1_;
	gboolean _tmp5_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->anonymous_w;
	if (_tmp1_ != NULL) {
		GtkRadioButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->anonymous_w;
		_tmp3_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = _tmp0_;
	result = _tmp5_;
	return result;
}


static void mount_operation_assistant_check_valid_inputs (MountOperationAssistant* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp8_;
	gboolean valid;
	const gchar* _tmp9_;
	AssistantOperation* _tmp10_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp1_ = mount_operation_assistant_is_anonymous (self);
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		GtkEntry* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp7_;
		_tmp3_ = self->priv->username_w;
		_tmp4_ = mount_operation_assistant_is_valid_entry (self, _tmp3_);
		if (_tmp4_) {
			GtkEntry* _tmp5_;
			gboolean _tmp6_ = FALSE;
			_tmp5_ = self->priv->domain_w;
			_tmp6_ = mount_operation_assistant_is_valid_entry (self, _tmp5_);
			_tmp2_ = _tmp6_;
		} else {
			_tmp2_ = FALSE;
		}
		_tmp7_ = _tmp2_;
		_tmp0_ = _tmp7_;
	}
	_tmp8_ = _tmp0_;
	valid = _tmp8_;
	_tmp9_ = self->priv->_label_button;
	if (_tmp9_ != NULL) {
		valid = FALSE;
	}
	_tmp10_ = self->priv->_assist;
	_tmp11_ = valid;
	assistant_allow_forward ((Assistant*) _tmp10_, _tmp11_);
}


static void mount_operation_assistant_send_reply (MountOperationAssistant* self, GMountOperationResult _result_) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->looping;
	if (_tmp0_) {
		GMountOperationResult _tmp1_;
		gtk_main_quit ();
		self->priv->looping = FALSE;
		_tmp1_ = _result_;
		g_mount_operation_reply ((GMountOperation*) self, _tmp1_);
	}
}


static void mount_operation_assistant_do_close (MountOperationAssistant* self, AssistantOperation* op, gboolean success) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	mount_operation_assistant_send_reply (self, G_MOUNT_OPERATION_ABORTED);
}


static void mount_operation_assistant_do_backward (MountOperationAssistant* self, Assistant* assist) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (assist != NULL);
	mount_operation_assistant_send_reply (self, G_MOUNT_OPERATION_ABORTED);
}


static void mount_operation_assistant_do_forward (MountOperationAssistant* self, Assistant* assist) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (assist != NULL);
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void mount_operation_assistant_do_prepare (MountOperationAssistant* self, Assistant* assist, GtkWidget* page) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (assist != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = self->priv->looping;
	if (_tmp0_) {
		GtkEntry* _tmp1_;
		GtkEntry* _tmp8_;
		GtkEntry* _tmp15_;
		GtkRadioButton* _tmp22_;
		GtkCheckButton* _tmp25_;
		_tmp1_ = self->priv->username_w;
		if (_tmp1_ != NULL) {
			GtkEntry* _tmp2_;
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gchar* txt;
			const gchar* _tmp5_;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			_tmp2_ = self->priv->username_w;
			_tmp3_ = gtk_entry_get_text (_tmp2_);
			_tmp4_ = g_strdup (_tmp3_);
			txt = _tmp4_;
			_tmp5_ = txt;
			_tmp6_ = string_strip (_tmp5_);
			_tmp7_ = _tmp6_;
			g_mount_operation_set_username ((GMountOperation*) self, _tmp7_);
			_g_free0 (_tmp7_);
			_g_free0 (txt);
		}
		_tmp8_ = self->priv->domain_w;
		if (_tmp8_ != NULL) {
			GtkEntry* _tmp9_;
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			gchar* txt;
			const gchar* _tmp12_;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			_tmp9_ = self->priv->domain_w;
			_tmp10_ = gtk_entry_get_text (_tmp9_);
			_tmp11_ = g_strdup (_tmp10_);
			txt = _tmp11_;
			_tmp12_ = txt;
			_tmp13_ = string_strip (_tmp12_);
			_tmp14_ = _tmp13_;
			g_mount_operation_set_domain ((GMountOperation*) self, _tmp14_);
			_g_free0 (_tmp14_);
			_g_free0 (txt);
		}
		_tmp15_ = self->priv->password_w;
		if (_tmp15_ != NULL) {
			GtkEntry* _tmp16_;
			const gchar* _tmp17_ = NULL;
			gchar* _tmp18_;
			gchar* txt;
			const gchar* _tmp19_;
			gchar* _tmp20_ = NULL;
			gchar* _tmp21_;
			_tmp16_ = self->priv->password_w;
			_tmp17_ = gtk_entry_get_text (_tmp16_);
			_tmp18_ = g_strdup (_tmp17_);
			txt = _tmp18_;
			_tmp19_ = txt;
			_tmp20_ = string_strip (_tmp19_);
			_tmp21_ = _tmp20_;
			g_mount_operation_set_password ((GMountOperation*) self, _tmp21_);
			_g_free0 (_tmp21_);
			_g_free0 (txt);
		}
		_tmp22_ = self->priv->anonymous_w;
		if (_tmp22_ != NULL) {
			GtkRadioButton* _tmp23_;
			gboolean _tmp24_ = FALSE;
			_tmp23_ = self->priv->anonymous_w;
			_tmp24_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp23_);
			g_mount_operation_set_anonymous ((GMountOperation*) self, _tmp24_);
		}
		_tmp25_ = self->priv->remember_w;
		if (_tmp25_ != NULL) {
			GPasswordSave _tmp26_ = 0;
			GtkCheckButton* _tmp27_;
			gboolean _tmp28_ = FALSE;
			GPasswordSave _tmp29_;
			_tmp27_ = self->priv->remember_w;
			_tmp28_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp27_);
			if (_tmp28_) {
				_tmp26_ = G_PASSWORD_SAVE_PERMANENTLY;
			} else {
				_tmp26_ = G_PASSWORD_SAVE_NEVER;
			}
			_tmp29_ = _tmp26_;
			g_mount_operation_set_password_save ((GMountOperation*) self, _tmp29_);
		}
		mount_operation_assistant_send_reply (self, G_MOUNT_OPERATION_HANDLED);
	}
}


const gchar* mount_operation_assistant_get_label_button (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_button;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_button (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_button);
	self->priv->_label_button = _tmp1_;
	g_object_notify ((GObject *) self, "label-button");
}


const gchar* mount_operation_assistant_get_label_help (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_help;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_help (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_help);
	self->priv->_label_help = _tmp1_;
	g_object_notify ((GObject *) self, "label-help");
}


const gchar* mount_operation_assistant_get_label_title (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_title;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_title (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_title);
	self->priv->_label_title = _tmp1_;
	g_object_notify ((GObject *) self, "label-title");
}


const gchar* mount_operation_assistant_get_label_username (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_username;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_username (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_username);
	self->priv->_label_username = _tmp1_;
	g_object_notify ((GObject *) self, "label-username");
}


const gchar* mount_operation_assistant_get_label_password (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_password;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_password (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_password);
	self->priv->_label_password = _tmp1_;
	g_object_notify ((GObject *) self, "label-password");
}


const gchar* mount_operation_assistant_get_label_show_password (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_show_password;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_show_password (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_show_password);
	self->priv->_label_show_password = _tmp1_;
	g_object_notify ((GObject *) self, "label-show-password");
}


const gchar* mount_operation_assistant_get_label_remember_password (MountOperationAssistant* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_remember_password;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_label_remember_password (MountOperationAssistant* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label_remember_password);
	self->priv->_label_remember_password = _tmp1_;
	g_object_notify ((GObject *) self, "label-remember-password");
}


Window mount_operation_assistant_get_xid (MountOperationAssistant* self) {
	Window result;
	Window _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_xid;
	result = _tmp0_;
	return result;
}


static void mount_operation_assistant_set_xid (MountOperationAssistant* self, Window value) {
	Window _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_xid = _tmp0_;
	g_object_notify ((GObject *) self, "xid");
}


gboolean mount_operation_assistant_get_go_forward (MountOperationAssistant* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_go_forward;
	result = _tmp0_;
	return result;
}


void mount_operation_assistant_set_go_forward (MountOperationAssistant* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_go_forward = _tmp0_;
	g_object_notify ((GObject *) self, "go-forward");
}


AssistantOperation* mount_operation_assistant_get_assist (MountOperationAssistant* self) {
	AssistantOperation* result;
	AssistantOperation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_assist;
	result = _tmp0_;
	return result;
}


static void mount_operation_assistant_set_assist (MountOperationAssistant* self, AssistantOperation* value) {
	AssistantOperation* _tmp0_;
	AssistantOperation* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_assist);
	self->priv->_assist = _tmp1_;
	g_object_notify ((GObject *) self, "assist");
}


static GObject * mount_operation_assistant_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	MountOperationAssistant * self;
	parent_class = G_OBJECT_CLASS (mount_operation_assistant_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = MOUNT_OPERATION_ASSISTANT (obj);
	g_signal_connect (self, "notify::go-forward", (GCallback) mount_operation_assistant_go_forward_changed, self);
	return obj;
}


static void mount_operation_assistant_class_init (MountOperationAssistantClass * klass) {
	mount_operation_assistant_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MountOperationAssistantPrivate));
	G_MOUNT_OPERATION_CLASS (klass)->aborted = mount_operation_assistant_real_aborted;
	G_MOUNT_OPERATION_CLASS (klass)->ask_password = mount_operation_assistant_real_ask_password;
	G_MOUNT_OPERATION_CLASS (klass)->ask_question = mount_operation_assistant_real_ask_question;
	G_OBJECT_CLASS (klass)->get_property = _vala_mount_operation_assistant_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mount_operation_assistant_set_property;
	G_OBJECT_CLASS (klass)->constructor = mount_operation_assistant_constructor;
	G_OBJECT_CLASS (klass)->finalize = mount_operation_assistant_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_BUTTON, g_param_spec_string ("label-button", "label-button", "label-button", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_HELP, g_param_spec_string ("label-help", "label-help", "label-help", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_TITLE, g_param_spec_string ("label-title", "label-title", "label-title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_USERNAME, g_param_spec_string ("label-username", "label-username", "label-username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_PASSWORD, g_param_spec_string ("label-password", "label-password", "label-password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_SHOW_PASSWORD, g_param_spec_string ("label-show-password", "label-show-password", "label-show-password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_LABEL_REMEMBER_PASSWORD, g_param_spec_string ("label-remember-password", "label-remember-password", "label-remember-password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_XID, g_param_spec_int ("xid", "xid", "xid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_GO_FORWARD, g_param_spec_boolean ("go-forward", "go-forward", "go-forward", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUNT_OPERATION_ASSISTANT_ASSIST, g_param_spec_object ("assist", "assist", "assist", TYPE_ASSISTANT_OPERATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("button_clicked", TYPE_MOUNT_OPERATION_ASSISTANT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void mount_operation_assistant_instance_init (MountOperationAssistant * self) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	self->priv = MOUNT_OPERATION_ASSISTANT_GET_PRIVATE (self);
	_tmp0_ = _ ("Connect to Server");
	_tmp1_ = g_strdup (_tmp0_);
	self->priv->_label_title = _tmp1_;
	_tmp2_ = _ ("_Username");
	_tmp3_ = g_strdup (_tmp2_);
	self->priv->_label_username = _tmp3_;
	_tmp4_ = _ ("_Password");
	_tmp5_ = g_strdup (_tmp4_);
	self->priv->_label_password = _tmp5_;
	_tmp6_ = _ ("S_how password");
	_tmp7_ = g_strdup (_tmp6_);
	self->priv->_label_show_password = _tmp7_;
	_tmp8_ = _ ("_Remember password");
	_tmp9_ = g_strdup (_tmp8_);
	self->priv->_label_remember_password = _tmp9_;
	self->priv->_go_forward = FALSE;
	self->priv->looping = FALSE;
}


static void mount_operation_assistant_finalize (GObject* obj) {
	MountOperationAssistant * self;
	self = MOUNT_OPERATION_ASSISTANT (obj);
	_g_free0 (self->priv->_label_button);
	_g_free0 (self->priv->_label_help);
	_g_free0 (self->priv->_label_title);
	_g_free0 (self->priv->_label_username);
	_g_free0 (self->priv->_label_password);
	_g_free0 (self->priv->_label_show_password);
	_g_free0 (self->priv->_label_remember_password);
	_g_object_unref0 (self->priv->_assist);
	_g_object_unref0 (self->priv->password_page);
	_g_object_unref0 (self->priv->layout);
	_g_object_unref0 (self->priv->table);
	_g_object_unref0 (self->priv->anonymous_w);
	_g_object_unref0 (self->priv->remember_w);
	_g_object_unref0 (self->priv->username_w);
	_g_object_unref0 (self->priv->domain_w);
	_g_object_unref0 (self->priv->password_w);
	G_OBJECT_CLASS (mount_operation_assistant_parent_class)->finalize (obj);
}


/**
 * This class can be used by backends in one of two ways:
 * 1) Traditional way, by having this ask the user for info and then sending
 *    a reply signal.
 * 2) Or by driving the authentication themselves in some secret way.  If so,
 *    they will ask for a button to be shown to start the authentication.
 *    When they are done, they will set the 'go_forward' property to true.
 *    This is used by the U1 backend.
 */
GType mount_operation_assistant_get_type (void) {
	static volatile gsize mount_operation_assistant_type_id__volatile = 0;
	if (g_once_init_enter (&mount_operation_assistant_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MountOperationAssistantClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mount_operation_assistant_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MountOperationAssistant), 0, (GInstanceInitFunc) mount_operation_assistant_instance_init, NULL };
		GType mount_operation_assistant_type_id;
		mount_operation_assistant_type_id = g_type_register_static (g_mount_operation_get_type (), "MountOperationAssistant", &g_define_type_info, 0);
		g_once_init_leave (&mount_operation_assistant_type_id__volatile, mount_operation_assistant_type_id);
	}
	return mount_operation_assistant_type_id__volatile;
}


static void _vala_mount_operation_assistant_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MountOperationAssistant * self;
	self = MOUNT_OPERATION_ASSISTANT (object);
	switch (property_id) {
		case MOUNT_OPERATION_ASSISTANT_LABEL_BUTTON:
		g_value_set_string (value, mount_operation_assistant_get_label_button (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_HELP:
		g_value_set_string (value, mount_operation_assistant_get_label_help (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_TITLE:
		g_value_set_string (value, mount_operation_assistant_get_label_title (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_USERNAME:
		g_value_set_string (value, mount_operation_assistant_get_label_username (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_PASSWORD:
		g_value_set_string (value, mount_operation_assistant_get_label_password (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_SHOW_PASSWORD:
		g_value_set_string (value, mount_operation_assistant_get_label_show_password (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_REMEMBER_PASSWORD:
		g_value_set_string (value, mount_operation_assistant_get_label_remember_password (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_XID:
		g_value_set_int (value, mount_operation_assistant_get_xid (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_GO_FORWARD:
		g_value_set_boolean (value, mount_operation_assistant_get_go_forward (self));
		break;
		case MOUNT_OPERATION_ASSISTANT_ASSIST:
		g_value_set_object (value, mount_operation_assistant_get_assist (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_mount_operation_assistant_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MountOperationAssistant * self;
	self = MOUNT_OPERATION_ASSISTANT (object);
	switch (property_id) {
		case MOUNT_OPERATION_ASSISTANT_LABEL_BUTTON:
		mount_operation_assistant_set_label_button (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_HELP:
		mount_operation_assistant_set_label_help (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_TITLE:
		mount_operation_assistant_set_label_title (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_USERNAME:
		mount_operation_assistant_set_label_username (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_PASSWORD:
		mount_operation_assistant_set_label_password (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_SHOW_PASSWORD:
		mount_operation_assistant_set_label_show_password (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_LABEL_REMEMBER_PASSWORD:
		mount_operation_assistant_set_label_remember_password (self, g_value_get_string (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_XID:
		mount_operation_assistant_set_xid (self, g_value_get_int (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_GO_FORWARD:
		mount_operation_assistant_set_go_forward (self, g_value_get_boolean (value));
		break;
		case MOUNT_OPERATION_ASSISTANT_ASSIST:
		mount_operation_assistant_set_assist (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



